
// WrapParticles3D.java
// Andrew Davison, April 2005, ad@fivedots.coe.psu.ac.th

/* Tři různé implementace částicových systémů
      * body v objektu typu PointArray
      * úsečky v objektu typu LineArray
      * čtyřúhelníky v objektu typu QuadArray

   Geometrie se ukládají pomocí odkazu BY_REFERENCE a aktualzují
   prostřednictvím tříd implementujících rozhraní GeometryUpdater.
   
   Ukázková aplikace QuadArray demonstruje, jak aplikovat jednu
   texturu na všechy čtyřúhelníky a jak zkloubit texturu s barvou.

   Ukázkové aplikace jsou variantami na fontánu částic 
   vystřelovaných z počátku po poarabolických drahách. Částice
   se poté, co klesnou pod rovinu XZ, použijí znovu.
*/


import javax.swing.*;
import java.awt.*;

import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.vp.*;



public class WrapParticles3D extends JPanel
// Uchovává 3D-canvas, na nemž se zobrazuje nactený obrázek
{
  private static final int PWIDTH = 512;   // velikost panelu
  private static final int PHEIGHT = 512; 
  private static final int BOUNDSIZE = 100;  // větší než virtuální svět
  private static final Point3d USERPOSN = new Point3d(0,5,20);
    // počáteční pozice uživatele

  private SimpleUniverse su;
  private BranchGroup sceneBG;
  private BoundingSphere bounds;   // pro uzly prostredí


  public WrapParticles3D(int numParticles, int fountainChoice)
  // zkonstruuje 3D-canvas
  {
    setLayout( new BorderLayout() );
    setOpaque( false );

    setPreferredSize( new Dimension(PWIDTH, PHEIGHT));

    GraphicsConfiguration config =
					SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas3D = new Canvas3D(config);
    add("Center", canvas3D);
    canvas3D.setFocusable(true);
    canvas3D.requestFocus();    // vstup od klávesnice je náš, přijímáme tedy její události

    su = new SimpleUniverse(canvas3D);

    createSceneGraph(numParticles, fountainChoice);
    initUserPosition();        // nastav stanoviště pozorovatele
    orbitControls(canvas3D);   // ovládací prvky pro pohyb tohoto stanoviště
    
    su.addBranchGraph( sceneBG );
  } // konec metody: WrapParticles3D()



  private void createSceneGraph(int numParts, int fountainChoice) 
  // inicializuje scénu
  { 
    sceneBG = new BranchGroup();
    bounds = new BoundingSphere(new Point3d(0,0,0), BOUNDSIZE);   

    lightScene();         // přidej světla
    addBackground();      // přidej oblohu
    sceneBG.addChild( new CheckerFloor().getBG() );  // přidej podlahu

    switch(fountainChoice) {
      case 1: addPointsFountain(numParts); break;
      case 2: addLinesFountain(numParts); break;
      case 3: addQuadFountain(numParts); break;
      default: break;   // say nothing
    }

    sceneBG.compile();   // zafixuj scénu
  } // konec metody: createSceneGraph()


  private void lightScene()
  /* Jedno ambientní svetlo, 2 smerová svetla */
  {
    Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

    // připrav ambientní světlo
    AmbientLight ambientLightNode = new AmbientLight(white);
    ambientLightNode.setInfluencingBounds(bounds);
    sceneBG.addChild(ambientLightNode);

    // připrav směrová světla
    Vector3f light1Direction  = new Vector3f(-1.0f, -1.0f, -1.0f);
       // vlevo, dolů, dozadu 
    Vector3f light2Direction  = new Vector3f(1.0f, -1.0f, 1.0f);
       // vpravo, dolu, dopredu

    DirectionalLight light1 = 
            new DirectionalLight(white, light1Direction);
    light1.setInfluencingBounds(bounds);
    sceneBG.addChild(light1);

    DirectionalLight light2 = 
        new DirectionalLight(white, light2Direction);
    light2.setInfluencingBounds(bounds);
    sceneBG.addChild(light2);
  }  // konec metody: lightScene()



  private void addBackground()
  // modrá obhloha
  { Background back = new Background();
    back.setApplicationBounds( bounds );
    back.setColor(0.17f, 0.65f, 0.92f);    // barva oblohy
    sceneBG.addChild( back );
  }  // konec metody: addBackground()



  private void orbitControls(Canvas3D c)
  /* Třída OrbitBehaviour umožňuje uživateli otáčet, přibližovat a oddalovat scénu. */
  { OrbitBehavior orbit = 
		new OrbitBehavior(c, OrbitBehavior.REVERSE_ALL);
    orbit.setSchedulingBounds(bounds);

    ViewingPlatform vp = su.getViewingPlatform();
    vp.setViewPlatformBehavior(orbit);	    
  }  // konec metody: orbitControls()



  private void initUserPosition()
  // Pomocí metody lookAt() nastaví počáteční výhled uživatele
  {
    ViewingPlatform vp = su.getViewingPlatform();
    TransformGroup steerTG = vp.getViewPlatformTransform();

    Transform3D t3d = new Transform3D();
    steerTG.getTransform(t3d);

    // argumenty jsou: pozice pozorovatele, kam se dívá, směr nahoru
    t3d.lookAt( USERPOSN, new Point3d(0,0,0), new Vector3d(0,1,0));
    t3d.invert();

    steerTG.setTransform(t3d);
  }  // konec metody: initUserPosition()


// -------------------------- fontánky -------------


  private void addPointsFountain(int numParts)
  {
    PointParticles ptsFountain = new PointParticles(numParts, 20);   // časová prodleva

    // přesuň počáteční pozici částic do bodu (2,0,1)
    TransformGroup posnTG = new TransformGroup();
    Transform3D trans = new Transform3D();
    trans.setTranslation( new Vector3d(2.0f, 0.0f, 1.0f) );
    posnTG.setTransform(trans);
    posnTG.addChild(ptsFountain); 
    sceneBG.addChild( posnTG );

    // časované chování pro animaci fontány
    Behavior partBeh = ptsFountain.getParticleBeh();
    partBeh.setSchedulingBounds( bounds );
    sceneBG.addChild(partBeh);
  } // konec metody: addPointsFountain()


  private void addQuadFountain(int numParts)
  {
    Quadmarticles quadsFountain = new Quadmarticles(numParts, 20);   // časová prodleva
    sceneBG.addChild(quadsFountain);   // začně od počátku

    // časované chování pro animaci fontány
    Behavior partBeh = quadsFountain.getParticleBeh();
    partBeh.setSchedulingBounds( bounds );
    sceneBG.addChild(partBeh);
  } // konec metody: addQuadFountain()


  private void addLinesFountain(int numParts)
  {
    LineParticles linesFountain = 
				new LineParticles(numParts, 20);   // časová prodleva
    sceneBG.addChild(linesFountain);   // začně od počátku

    // časované chování pro animaci fontány
    Behavior partBeh = linesFountain.getParticleBeh();
    partBeh.setSchedulingBounds( bounds );
    sceneBG.addChild(partBeh);
  } // konec metody: addLinesRefFountain()



} // konec třídy: WrapParticles3D